#!/usr/bin/env python

"""
Very basic "human identifier" image generator.

Uses libgd and the dejavusans-mono-bold TTF font, and minimal obfuscation
techniques.  Not meant for an Internet-facing application where OCR, etc
is a real risk;  The "security" measures here are meant to prevent flooding
of the auth server by malicious users only.

Image is drawn normally and then obfuscated by drawing white lines over it.

Image content is derived from the content of the GET string, which is 
obfuscated with a 3des private key.  This key must match the config used in
the companion script, radios.cgi.

http://.../image.cgi?text=3des-encrypded-data

mkershaw@arubanetworks.com
http://labs.arubanetworks.com

"""

# 12 bytes/24 hex digit DES key
# Must match the key in the calling cgi (radius.cgi)
# and should be generated from proper random data
PRIVATEKEY="010101010101010101010101"

# If the TTF file is not stored in the CGI directory, specify
# where it is kept
FONTPATH="."

import gd, os, sys, cStringIO, urllib2, encodings, pyDes, random
import cgi, cgitb

os.environ["GDFONTPATH"] = FONTPATH

FONT = "dejavusansmonobold"

def simple():
    im = gd.image((300, 100))

    white = im.colorAllocate((255, 255, 255))
    black = im.colorAllocate((0, 0, 0))
    blue = im.colorAllocate((0, 0, 255))
    yellow = im.colorAllocate((255, 255, 0))
    white = im.colorAllocate((255, 255, 255))

    im.colorTransparent(white)
    im.interlace(1)

    im.rectangle((0,0), (299,99), black)

    try:
        form = cgi.FieldStorage() 
        text = form.getvalue("text");
        k = pyDes.triple_des(PRIVATEKEY)
        s = k.decrypt(text.decode("hex"), "*")

        v = s.split(":")
        if (len(v) != 3):
            s = "error"
        else:
            s = v[2]
    except:
        s = "error"

    im.string_ttf(FONT, 72.0, 0.0, (5, 90), s, black)

    for i in range(1, 150):
        im.line((random.uniform(1, 299), random.uniform(1, 99)),
                (random.uniform(1, 299), random.uniform(1, 99)), white)

    # Print the PNG out to our caller, we get included as <img>
    print "Content-type: image/png\n"
    im.writePng(sys.stdout)

simple()

